/*
 *		[1.0] - First release
 *		  |
 *		  +———[1.1] - Make a new code of stop victim in trap
 */

#include <amxmodx>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombieplague>

// https://forums.alliedmods.net/showthread.php?t=184780
#include <beams>

#define is_user_valid(%0)				(%0 && 0 < %0 < 33)
#define IsCustomItem(%0) 				(pev(%0, pev_impulse) == WEAPON_SPECIAL_CODE)
#define weaponHasMaxHits(%0)			(get_pdata_int(%0, m_iHitCount, linux_diff_weapon) >= WEAPON_HIT_COUNT_MODE)

#define PDATA_SAFE 						2

#define m_iHitCount						m_iGlock18ShotsFired
#define m_iTrapsCount					m_iFamasShotsFired

#define pev_bScratched					pev_iuser3 // user scratched (CPlayer)
#define pev_bTrapped					pev_iuser4 // user trapped (CPlayer)
#define pev_iBeamFlyEnt					pev_iuser1 // flying entity for beam (CEntity)
#define pev_vStart 						pev_vuser1 // vecStart of beam (CEntity)
#define pev_vEnd 						pev_vuser2 // vecEndPos of beam (CEntity)

#define SERVER_HAS_MONEY_SYSTEM			false // [ 'true' = if enable money | 'false' = if money has removed ]

#define HIDEHUD_MONEY					(1<<5)
#define HIDEHUD_CROSSHAIR 				(1<<6)

enum
{
	WPNSTATE_TRAPS = 0,
	WPNSTATE_ZOOM,
	WPNSTATE_ZOOM_SHOOT
};

/* ~ [ Weapon Animations ] ~ */
#define WEAPON_ANIM_IDLE_TIME 			61/30.0
#define WEAPON_ANIM_SHOOT_TIME 			56/30.0
#define WEAPON_ANIM_RELOAD_TIME 		61/30.0
#define WEAPON_ANIM_DRAW_TIME 			31/30.0
#define WEAPON_ANIM_RELOAD_SKILL_TIME	61/30.0

#define WEAPON_ANIM_IDLE 				0
#define WEAPON_ANIM_SHOOT 				1
#define WEAPON_ANIM_SHOOT_NET			2
#define WEAPON_ANIM_RELOAD 				3
#define WEAPON_ANIM_DRAW 				4
// #define WEAPON_ANIM_TIGER_SPAWN 		5
#define WEAPON_ANIM_ZOOM_TARGET			12
#define WEAPON_ANIM_ZOOM				13

/* ~ [ Weapon Settings ] ~ */
new const WEAPON_REFERENCE[] = 			"weapon_ak47";
new const WEAPON_WEAPONLIST[][] =		{ "weapon_m95tiger", "weapon_m95tiger_2" };
new const WEAPON_NATIVE[] = 			"zp_give_user_m95tiger";
new const WEAPON_MODEL_VIEW[] =			"models/tiger_sponsor/v_m95tiger_fx.mdl";
new const WEAPON_MODEL_PLAYER[] = 		"models/tiger_sponsor/p_m95tiger.mdl";
new const WEAPON_MODEL_WORLD[] = 		"models/tiger_sponsor/w_m95tiger.mdl";
new const WEAPON_SOUND_FIRE[][] =
{
	"tiger_sponsor/m95tiger-1.wav",
	"tiger_sponsor/m95tiger-2.wav",
	"tiger_sponsor/m95tiger-3.wav"
};

const WEAPON_SPECIAL_CODE = 			891285915;
const WEAPON_BODY = 					0;

const WEAPON_TRAPS_COUNT =				7;
const WEAPON_HIT_COUNT_MODE =			10;
const WEAPON_MAX_CLIP = 				20;
const WEAPON_DEFAULT_AMMO = 			80;
const Float: WEAPON_RATE = 				1.7;
const Float: WEAPON_PUNCHANGLE = 		1.04;
const Float: WEAPON_DAMAGE = 			8.0; // best variables ~12.0 and more

new const iWeaponList[] = 				{ 2, 90, -1, -1, 0, 1, 28, 0 };

new const WEAPON_RESOURCES_SPRITES[][] = 
{
	"sprites/tiger_sponsor/ef_m95tiger_nethit.spr"
};

/* ~ [ Beams ] ~ */
new const ENTITY_BEAM_CLASSNAME[] = 	"beam_m95tiger";
new const ENTITY_BEAM_SPRITE[] = 		"sprites/laserbeam.spr";
const Float: ENTITY_BEAM_NEXTTHINK = 	0.07;
const Float: ENTITY_BEAM_WIDTH = 		40.0;
const Float: ENTITY_BEAM_BRIGHTNESS = 	255.0;
const Float: ENTITY_BEAM_SCROLLRATE = 	10.0;
const Float: ENTITY_BEAM_SPEED =		1000.0;
#define ENTITY_BEAM_COLOR				{255.0, 128.0, 0.0}

/* ~ [ Entity: Net Missile ] ~ */
new const ENTITY_NETM_CLASSNAME[] =		"ent_net_missilex";
new const ENTITY_NETM_MODEL[] = 		"models/tiger_sponsor/ef_m95tiger_net.mdl";
const Float: ENTITY_NETM_SPEED =		1500.0;

/* ~ [ Entity: Net Trap ] ~ */
new const ENTITY_NETTRAP_CLASSNAME[] =	"ent_net_trapx";
new const ENTITY_NETTRAP_MODEL[] =		"models/tiger_sponsor/ef_m95tiger_nethit.mdl";

/* ~ [ Entity: Tiger ] ~ */
new const ENTITY_TIGER_CLASSNAME[] =	"ent_tigerx";
new const ENTITY_TIGER_MODEL[] =		"models/tiger_sponsor/ef_m95tiger.mdl";
new const ENTITY_TIGER_SOUND[] =		"tiger_sponsor/m95tiger_tiger.wav";
const Float: ENTITY_TIGER_SPEED =		1000.0;
const Float: ENTITY_TIGER_DMGTIME = 	0.1;
#define ENTITY_TIGER_DAMAGE				random_float(400.0, 600.0)
const ENTITY_TIGER_DMGTYPE =			DMG_BULLET|DMG_NEVERGIB;

/* ~ [ Entity: Tiger Scratch ] ~ */
new const ENTITY_SCRATCH_CLASSNAME[] =	"ent_scratchx";
new const ENTITY_SCRATCH_SPRITE[] = 	"sprites/tiger_sponsor/ef_m95tiger_scratch.spr";
const Float: ENTITY_SCRATCH_LIFETIME =	2.5;

/* ~ [ Offsets ] ~ */
// Linux extra offsets
#define linux_diff_weapon 4
#define linux_diff_player 5

// CWeaponBox
#define m_rgpPlayerItems_CWeaponBox 34

// CBasePlayerItem
#define m_pPlayer 41
#define m_pNext 42
#define m_iId 43

// CBasePlayerWeapon
#define m_flNextPrimaryAttack 46
#define m_flNextSecondaryAttack 47
#define m_flTimeWeaponIdle 48
#define m_iPrimaryAmmoType 49
#define m_iClip 51
#define m_fInReload 54
#define m_iGlock18ShotsFired 70
#define m_iFamasShotsFired 72
#define m_iWeaponState 74

// CBaseMonster
#define m_LastHitGroup 75
#define m_flNextAttack 83

// CBasePlayer
#define m_iLastZoom 109
#define m_bResumeZoom 110 // 440 / 4
#define m_iHideHUD 361
#define m_iClientHideHUD 362
#define m_iFOV 363
#define m_rpgPlayerItems 367
#define m_pActiveItem 373
#define m_rgAmmo 376

/* ~ [ Params ] ~ */
new gl_iszAllocString_Entity,
	gl_iszAllocString_ModelView,
	gl_iszAllocString_ModelPlayer,
	gl_iszAllocString_InfoTarget,

	gl_iszAllocString_NetMissile,
	gl_iszAllocString_NetTrap,
	gl_iszAllocString_Scratch,
	gl_iszAllocString_Tiger,
	gl_iszAllocString_Beam;

new gl_iszModelIndex_Resources[sizeof WEAPON_RESOURCES_SPRITES];

new bool: gl_bClientDataUpdated;

new HamHook: gl_HamHook_TraceAttack[4];

new gl_iMsgID_Weaponlist,
	gl_iMsgID_HideWeapon,
	gl_iMsgID_StatusIcon,
	gl_iMsgID_CurWeapon,
	gl_iItemID;

public plugin_init()
{
	register_plugin("[ZP] Weapon: M95 White Tiger", "1.1", "xUnicorn (t3rkecorejz) / Batcoh: Code base");

	// Events
	register_event("HLTV", "EV_RoundStart", "a", "1=0", "2=0");

	// Forwards
	register_forward(FM_UpdateClientData,	"FM_Hook_UpdateClientData_Post", true);
	register_forward(FM_SetModel, 			"FM_Hook_SetModel_Pre", false);

	// Weapon
	RegisterHam(Ham_CS_Item_GetMaxSpeed,	WEAPON_REFERENCE,	"CWeapon__GetMaxSpeed_Pre", false);
	RegisterHam(Ham_Item_Holster,			WEAPON_REFERENCE,	"CWeapon__Holster_Post", true);
	RegisterHam(Ham_Item_Deploy,			WEAPON_REFERENCE,	"CWeapon__Deploy_Post", true);
	RegisterHam(Ham_Item_PostFrame,			WEAPON_REFERENCE,	"CWeapon__PostFrame_Pre", false);
	RegisterHam(Ham_Item_AddToPlayer,		WEAPON_REFERENCE,	"CWeapon__AddToPlayer_Post", true);
	RegisterHam(Ham_Weapon_Reload,			WEAPON_REFERENCE,	"CWeapon__Reload_Pre", false);
	RegisterHam(Ham_Weapon_WeaponIdle,		WEAPON_REFERENCE,	"CWeapon__WeaponIdle_Pre", false);
	RegisterHam(Ham_Weapon_PrimaryAttack,	WEAPON_REFERENCE,	"CWeapon__PrimaryAttack_Pre", false);
	RegisterHam(Ham_Weapon_SecondaryAttack, WEAPON_REFERENCE, 	"CWeapon__SecondaryAtack_Pre", false);

	// Entity
	RegisterHam(Ham_Touch,					"info_target",		"CEntity__Touch_Pre", false);
	RegisterHam(Ham_Think,					"info_target",		"CEntity__Think_Pre", false);
	RegisterHam(Ham_Think, 					"beam",				"CBeam__Think_Pre", false);
	
	// Trace Attack
	gl_HamHook_TraceAttack[0] = RegisterHam(Ham_TraceAttack,	"func_breakable",	"CEntity__TraceAttack_Pre", false);
	gl_HamHook_TraceAttack[1] = RegisterHam(Ham_TraceAttack,	"info_target",		"CEntity__TraceAttack_Pre", false);
	gl_HamHook_TraceAttack[2] = RegisterHam(Ham_TraceAttack,	"player",			"CEntity__TraceAttack_Pre", false);
	gl_HamHook_TraceAttack[3] = RegisterHam(Ham_TraceAttack,	"hostage_entity",	"CEntity__TraceAttack_Pre", false);
	
	fm_ham_hook(false);

	// Messages
	gl_iMsgID_Weaponlist = get_user_msgid("WeaponList");
	gl_iMsgID_HideWeapon = get_user_msgid("HideWeapon");
	gl_iMsgID_StatusIcon = get_user_msgid("StatusIcon");
	gl_iMsgID_CurWeapon = get_user_msgid("CurWeapon");

	// Alloc String
	gl_iszAllocString_Entity = engfunc(EngFunc_AllocString, WEAPON_REFERENCE);
	gl_iszAllocString_ModelView = engfunc(EngFunc_AllocString, WEAPON_MODEL_VIEW);
	gl_iszAllocString_ModelPlayer = engfunc(EngFunc_AllocString, WEAPON_MODEL_PLAYER);
	gl_iszAllocString_InfoTarget = engfunc(EngFunc_AllocString, "info_target");

	gl_iszAllocString_NetMissile = engfunc(EngFunc_AllocString, ENTITY_NETM_CLASSNAME);
	gl_iszAllocString_NetTrap = engfunc(EngFunc_AllocString, ENTITY_NETTRAP_CLASSNAME);
	gl_iszAllocString_Scratch = engfunc(EngFunc_AllocString, ENTITY_SCRATCH_CLASSNAME);
	gl_iszAllocString_Tiger = engfunc(EngFunc_AllocString, ENTITY_TIGER_CLASSNAME);
	gl_iszAllocString_Beam = engfunc(EngFunc_AllocString, ENTITY_BEAM_CLASSNAME);
}

public plugin_precache()
{
	new i;

	// Hook weapon
	for(i = 0; i < sizeof WEAPON_WEAPONLIST; i++)
	{
		register_clcmd(WEAPON_WEAPONLIST[i], "Command_HookWeapon");
		UTIL_PrecacheSpritesFromTxt(WEAPON_WEAPONLIST[i]);
	}

	// Precache models
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_VIEW);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_PLAYER);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_WORLD);

	engfunc(EngFunc_PrecacheModel, ENTITY_NETM_MODEL);
	engfunc(EngFunc_PrecacheModel, ENTITY_NETTRAP_MODEL);
	engfunc(EngFunc_PrecacheModel, ENTITY_TIGER_MODEL);
	engfunc(EngFunc_PrecacheModel, ENTITY_SCRATCH_SPRITE);
	
	// Precache sounds
	for(i = 0; i < sizeof WEAPON_SOUND_FIRE; i++)
		engfunc(EngFunc_PrecacheSound, WEAPON_SOUND_FIRE[i]);

	engfunc(EngFunc_PrecacheSound, ENTITY_TIGER_SOUND);

	UTIL_PrecacheSoundsFromModel(WEAPON_MODEL_VIEW);

	// Model Index
	for(i = 0; i < sizeof WEAPON_RESOURCES_SPRITES; i++)
		gl_iszModelIndex_Resources[i] = engfunc(EngFunc_PrecacheModel, WEAPON_RESOURCES_SPRITES[i]);
}

public plugin_natives() register_native(WEAPON_NATIVE, "Command_GiveWeapon", 1);

// [ Amxx ]
public Command_HookWeapon(iPlayer)
{
	engclient_cmd(iPlayer, WEAPON_REFERENCE);
	return PLUGIN_HANDLED;
}

public Command_GiveWeapon(iPlayer)
{
	static iEntity; iEntity = engfunc(EngFunc_CreateNamedEntity, gl_iszAllocString_Entity);
	if(iEntity <= 0) return 0;

	set_pev(iEntity, pev_impulse, WEAPON_SPECIAL_CODE);
	ExecuteHam(Ham_Spawn, iEntity);
	set_pdata_int(iEntity, m_iClip, WEAPON_MAX_CLIP, linux_diff_weapon);
	UTIL_DropWeapon(iPlayer, 1);

	if(!ExecuteHamB(Ham_AddPlayerItem, iPlayer, iEntity))
	{
		set_pev(iEntity, pev_flags, pev(iEntity, pev_flags) | FL_KILLME);
		return 0;
	}

	ExecuteHamB(Ham_Item_AttachToPlayer, iEntity, iPlayer);

	new iAmmoType = m_rgAmmo + get_pdata_int(iEntity, m_iPrimaryAmmoType, linux_diff_weapon);
	if(get_pdata_int(iPlayer, m_rgAmmo, linux_diff_player) < WEAPON_DEFAULT_AMMO)
		set_pdata_int(iPlayer, iAmmoType, WEAPON_DEFAULT_AMMO, linux_diff_player);

	set_pdata_int(iEntity, m_iTrapsCount, WEAPON_TRAPS_COUNT, linux_diff_weapon);

	emit_sound(iPlayer, CHAN_ITEM, "items/gunpickup2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	return 1;
}

// [ Zombie Plague ]
public zp_extra_item_selected(iPlayer, iItem)
{
	if(iItem == gl_iItemID)
		Command_GiveWeapon(iPlayer);
}

public zp_user_infected_pre(iPlayer)
{
	if(!is_user_connected(iPlayer)) return;

	new iItem = get_pdata_cbase(iPlayer, m_pActiveItem, linux_diff_player);
	UTIL_StatusIcon(iItem, iPlayer, 0);
}

// [ Events ]
public EV_RoundStart()
{
	new iEntity;
	iEntity = FM_NULLENT;
	while((iEntity = engfunc(EngFunc_FindEntityByString, iEntity, "classname", ENTITY_BEAM_CLASSNAME)))
		if(pev_valid(iEntity)) set_pev(iEntity, pev_flags, FL_KILLME);

	iEntity = FM_NULLENT;
	while((iEntity = engfunc(EngFunc_FindEntityByString, iEntity, "classname", ENTITY_NETM_CLASSNAME)))
		if(pev_valid(iEntity)) set_pev(iEntity, pev_flags, FL_KILLME);

	iEntity = FM_NULLENT;
	while((iEntity = engfunc(EngFunc_FindEntityByString, iEntity, "classname", ENTITY_NETTRAP_CLASSNAME)))
		if(pev_valid(iEntity)) set_pev(iEntity, pev_flags, FL_KILLME);

	iEntity = FM_NULLENT;
	while((iEntity = engfunc(EngFunc_FindEntityByString, iEntity, "classname", ENTITY_TIGER_CLASSNAME)))
		if(pev_valid(iEntity)) set_pev(iEntity, pev_flags, FL_KILLME);

	iEntity = FM_NULLENT;
	while((iEntity = engfunc(EngFunc_FindEntityByString, iEntity, "classname", ENTITY_SCRATCH_CLASSNAME)))
		if(pev_valid(iEntity)) set_pev(iEntity, pev_flags, FL_KILLME);
}

// [ Fakemeta ]
public FM_Hook_UpdateClientData_Post(iPlayer, SendWeapons, CD_Handle)
{
	if(!is_user_alive(iPlayer)) return;

	static iItem; iItem = get_pdata_cbase(iPlayer, m_pActiveItem, linux_diff_player);
	if(pev_valid(iItem) != PDATA_SAFE || !IsCustomItem(iItem)) return;

	static Float: flNextLight; pev(iItem, pev_fuser4, flNextLight);
	if(get_gametime() >= flNextLight)
	{
		flNextLight = get_gametime() + 1.0;
		set_pev(iItem, pev_fuser4, flNextLight);

		static Float: vecOrigin[3]; pev(iPlayer, pev_origin, vecOrigin);

		message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, iPlayer);
		write_byte(TE_ELIGHT);
		write_short(iPlayer);
		engfunc(EngFunc_WriteCoord, (vecOrigin[0] + random_num(-20, 20)));
		engfunc(EngFunc_WriteCoord, (vecOrigin[1] + random_num(-20, 20)));
		engfunc(EngFunc_WriteCoord, (vecOrigin[2] + random_num(-10, 25)));
		write_coord(15);
		write_byte(255);
		write_byte(255);
		write_byte(255);
		write_byte(12);
		write_coord(0);
		message_end();
	}

	switch(get_pdata_int(iItem, m_iWeaponState, linux_diff_weapon))
	{
		case WPNSTATE_TRAPS:
		{
			static iFOV; iFOV = get_pdata_int(iPlayer, m_iFOV, linux_diff_player);
			if(iFOV != 89)
				set_pdata_int(iPlayer, m_iFOV, 89, linux_diff_player);

			if(!gl_bClientDataUpdated)
			{
				UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[0], true);
				CPlayer__DefaultCrosshair(iPlayer, false);

				gl_bClientDataUpdated = true;
			}
		}
		case WPNSTATE_ZOOM, WPNSTATE_ZOOM_SHOOT:
		{
			if(!gl_bClientDataUpdated)
			{
				static iFOV; iFOV = get_pdata_int(iPlayer, m_iFOV, linux_diff_player);
				if(iFOV == 55)
				{
					UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[1], true);
					CPlayer__DefaultCrosshair(iPlayer, false);
					CPlayer__UpdateZoom(iPlayer, iItem);

					set_pdata_int(iItem, m_iWeaponState, WPNSTATE_ZOOM, linux_diff_weapon);
					gl_bClientDataUpdated = true;
				}
			}
		}
	}

	set_cd(CD_Handle, CD_flNextAttack, get_gametime() + 0.001);
}

public FM_Hook_SetModel_Pre(iEntity)
{
	static i, szClassName[32], iItem;
	pev(iEntity, pev_classname, szClassName, charsmax(szClassName));

	if(!equal(szClassName, "weaponbox")) return FMRES_IGNORED;

	for(i = 0; i < 6; i++)
	{
		iItem = get_pdata_cbase(iEntity, m_rgpPlayerItems_CWeaponBox + i, linux_diff_weapon);

		if(pev_valid(iItem) == PDATA_SAFE && IsCustomItem(iItem))
		{
			engfunc(EngFunc_SetModel, iEntity, WEAPON_MODEL_WORLD);
			set_pev(iEntity, pev_body, WEAPON_BODY);
			
			return FMRES_SUPERCEDE;
		}
	}

	return FMRES_IGNORED;
}

public FM_Hook_PlaybackEvent_Pre() return FMRES_SUPERCEDE;
public FM_Hook_TraceLine_Post(const Float: vecOrigin1[3], const Float: vecOrigin2[3], iFlags, iAttacker, iTrace)
{
	if(iFlags & IGNORE_MONSTERS) return FMRES_IGNORED;
	if(!is_user_alive(iAttacker)) return FMRES_IGNORED;

	static pHit; pHit = get_tr2(iTrace, TR_pHit);
	static Float: vecEndPos[3]; get_tr2(iTrace, TR_vecEndPos, vecEndPos);

	static iItem; iItem = get_pdata_cbase(iAttacker, m_pActiveItem, linux_diff_player);
	if(pev_valid(iItem) == PDATA_SAFE && IsCustomItem(iItem))
	{
		static iHits; iHits++;
		if((!pHit && iHits == 1) || iHits == get_weapon_penetration(iItem) || engfunc(EngFunc_PointContents, vecEndPos) == CONTENTS_SKY)
		{
			iHits = iHits == get_weapon_penetration(iItem) ? 0 : -1;
			get_tr2(iTrace, TR_vecEndPos, vecEndPos);
			CWeapon__Create_BeamLine(iAttacker, iItem, vecEndPos);
		}
	}

	if(pHit > 0) if(pev(pHit, pev_solid) != SOLID_BSP) return FMRES_IGNORED;

	engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, vecEndPos, 0);
	write_byte(TE_GUNSHOTDECAL);
	engfunc(EngFunc_WriteCoord, vecEndPos[0]);
	engfunc(EngFunc_WriteCoord, vecEndPos[1]);
	engfunc(EngFunc_WriteCoord, vecEndPos[2]);
	write_short(pHit > 0 ? pHit : 0);
	write_byte(random_num(41, 45));
	message_end();

	return FMRES_IGNORED;
}

// [ HamSandwich ]
public CWeapon__GetMaxSpeed_Pre(iItem)
{
	if(pev_valid(iItem) != PDATA_SAFE || !IsCustomItem(iItem)) return HAM_IGNORED;
	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);

	gl_bClientDataUpdated = false;
	UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[0], true);
	set_pdata_int(iPlayer, m_iFOV, 89, linux_diff_player);
	CPlayer__DefaultCrosshair(iPlayer, false);

	set_pdata_int(iItem, m_iWeaponState, WPNSTATE_TRAPS, linux_diff_weapon);

	return HAM_IGNORED;
}

public CWeapon__Holster_Post(iItem)
{
	if(pev_valid(iItem) != PDATA_SAFE || !IsCustomItem(iItem)) return;
	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);
	
	gl_bClientDataUpdated = false;
	set_pdata_int(iPlayer, m_iFOV, 90, linux_diff_player);
	CPlayer__DefaultCrosshair(iPlayer, true);
	UTIL_StatusIcon(iItem, iPlayer, 0);

	set_pdata_int(iItem, m_iWeaponState, WPNSTATE_TRAPS, linux_diff_weapon);
	set_pdata_float(iItem, m_flNextPrimaryAttack, 0.0, linux_diff_weapon);
	set_pdata_float(iItem, m_flNextSecondaryAttack, 0.0, linux_diff_weapon);
	set_pdata_float(iItem, m_flTimeWeaponIdle, 0.0, linux_diff_weapon);
	set_pdata_float(iPlayer, m_flNextAttack, 0.0, linux_diff_player);
}

public CWeapon__Deploy_Post(iItem)
{
	if(!IsCustomItem(iItem)) return;
	
	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);

	set_pev_string(iPlayer, pev_viewmodel2, gl_iszAllocString_ModelView);
	set_pev_string(iPlayer, pev_weaponmodel2, gl_iszAllocString_ModelPlayer);

	UTIL_StatusIcon(iItem, iPlayer, 0);
	UTIL_StatusIcon(iItem, iPlayer, 1);

	UTIL_SendWeaponAnim(iPlayer, WEAPON_ANIM_DRAW + (weaponHasMaxHits(iItem) ? 6 : 0));

	set_pdata_float(iPlayer, m_flNextAttack, WEAPON_ANIM_DRAW_TIME, linux_diff_player);
	set_pdata_float(iItem, m_flTimeWeaponIdle, WEAPON_ANIM_DRAW_TIME, linux_diff_weapon);
}

public CWeapon__PostFrame_Pre(iItem)
{
	if(!IsCustomItem(iItem)) return HAM_IGNORED;

	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);
	static iClip; iClip = get_pdata_int(iItem, m_iClip, linux_diff_weapon);
	static iButton; iButton = pev(iPlayer, pev_button);

	if(get_pdata_int(iItem, m_fInReload, linux_diff_weapon) == 1)
	{
		if(iButton & IN_ATTACK && iButton & IN_ATTACK2 && weaponHasMaxHits(iItem))
		{
			CWeapon__Create_Tiger(iPlayer);
			set_pdata_int(iItem, m_iHitCount, 0, linux_diff_weapon);
			set_pdata_float(iItem, m_flNextSecondaryAttack, 0.01, linux_diff_weapon);
		}

		// End reload
		if(get_pdata_float(iItem, m_flNextSecondaryAttack, linux_diff_weapon) < 0.0)
		{
			static iAmmoType; iAmmoType = m_rgAmmo + get_pdata_int(iItem, m_iPrimaryAmmoType, linux_diff_weapon);
			static iAmmo; iAmmo = get_pdata_int(iPlayer, iAmmoType, linux_diff_player);
			static j; j = min(WEAPON_MAX_CLIP - iClip, iAmmo);

			set_pdata_int(iItem, m_iClip, iClip + j, linux_diff_weapon);
			set_pdata_int(iPlayer, iAmmoType, iAmmo - j, linux_diff_player);
			set_pdata_int(iItem, m_fInReload, 0, linux_diff_weapon);
		}

		// Next Think
		set_pdata_float(iPlayer, m_flNextAttack, 0.1, linux_diff_player);
	}
	else
	{
		if(iButton & IN_ATTACK && iButton & IN_ATTACK2 && weaponHasMaxHits(iItem))
		{
			CWeapon__Create_Tiger(iPlayer);
			set_pdata_int(iItem, m_iHitCount, 0, linux_diff_weapon);
		}

		if(iButton & IN_ATTACK2 && get_pdata_float(iItem, m_flNextSecondaryAttack, linux_diff_weapon) < 0.0)
		{
			ExecuteHamB(Ham_Weapon_SecondaryAttack, iItem);

			iButton &= ~IN_ATTACK2;
			set_pev(iPlayer, pev_button, iButton);
		}
	}

	return HAM_IGNORED;
}

public CWeapon__AddToPlayer_Post(iItem, iPlayer)
{
	if(IsCustomItem(iItem)) UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[0], true);
	else if(pev(iItem, pev_impulse) == 0) UTIL_WeaponList(iPlayer, WEAPON_REFERENCE, false);
}

public CWeapon__Reload_Pre(iItem)
{
	if(!IsCustomItem(iItem)) return HAM_IGNORED;

	static iClip; iClip = get_pdata_int(iItem, m_iClip, linux_diff_weapon);
	if(iClip >= WEAPON_MAX_CLIP) return HAM_SUPERCEDE;

	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);
	static iAmmoType; iAmmoType = m_rgAmmo + get_pdata_int(iItem, m_iPrimaryAmmoType, linux_diff_weapon);
	if(get_pdata_int(iPlayer, iAmmoType, linux_diff_player) <= 0) return HAM_SUPERCEDE;
	if(get_pdata_int(iPlayer, m_iFOV, linux_diff_player) <= 89)
	{
		if(get_pdata_int(iItem, m_iWeaponState, linux_diff_weapon) == WPNSTATE_TRAPS)
			set_pdata_int(iPlayer, m_iFOV, 89, linux_diff_player);
		else
		{
			if(get_pdata_int(iPlayer, m_iFOV, linux_diff_player) != 90)
			{
				set_pdata_int(iPlayer, m_bResumeZoom, 1, linux_diff_player);
				set_pdata_int(iPlayer, m_iLastZoom, get_pdata_int(iPlayer, m_iFOV, linux_diff_player), linux_diff_player);

				set_pdata_int(iPlayer, m_iFOV, 90, linux_diff_player);
				set_pdata_int(iItem, m_iWeaponState, WPNSTATE_ZOOM_SHOOT, linux_diff_weapon);

				UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[1], true);
				CPlayer__DefaultCrosshair(iPlayer, true);
			}
		}

		gl_bClientDataUpdated = false;
	}

	set_pdata_int(iItem, m_iClip, 0, linux_diff_weapon);
	ExecuteHam(Ham_Weapon_Reload, iItem);
	set_pdata_int(iItem, m_iClip, iClip, linux_diff_weapon);
	set_pdata_int(iItem, m_fInReload, 1, linux_diff_weapon);

	UTIL_SendWeaponAnim(iPlayer, WEAPON_ANIM_RELOAD + (weaponHasMaxHits(iItem) ? 6 : 0));

	set_pdata_float(iItem, m_flNextPrimaryAttack, WEAPON_ANIM_RELOAD_TIME, linux_diff_weapon);
	set_pdata_float(iItem, m_flNextSecondaryAttack, WEAPON_ANIM_RELOAD_TIME, linux_diff_weapon);
	set_pdata_float(iItem, m_flTimeWeaponIdle, WEAPON_ANIM_RELOAD_TIME, linux_diff_weapon);
	set_pdata_float(iPlayer, m_flNextAttack, 0.1, linux_diff_player);

	return HAM_SUPERCEDE;
}

public CWeapon__WeaponIdle_Pre(iItem)
{
	if(!IsCustomItem(iItem) || get_pdata_float(iItem, m_flTimeWeaponIdle, linux_diff_weapon) > 0.0) return HAM_IGNORED;
	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);

	if(get_pdata_int(iItem, m_iWeaponState, linux_diff_weapon) == WPNSTATE_TRAPS)
	{
		UTIL_SendWeaponAnim(iPlayer, WEAPON_ANIM_IDLE + (weaponHasMaxHits(iItem) ? 6 : 0));
		set_pdata_float(iItem, m_flTimeWeaponIdle, WEAPON_ANIM_IDLE_TIME, linux_diff_weapon);
	}
	else CPlayer__UpdateZoom(iPlayer, iItem);

	return HAM_SUPERCEDE;
}

public CWeapon__PrimaryAttack_Pre(iItem)
{
	if(!IsCustomItem(iItem)) return HAM_IGNORED;

	if(get_pdata_int(iItem, m_iClip, linux_diff_weapon) == 0)
	{
		ExecuteHam(Ham_Weapon_PlayEmptySound, iItem);
		set_pdata_float(iItem, m_flNextPrimaryAttack, 0.2, linux_diff_weapon);

		return HAM_SUPERCEDE;
	}

	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);
	static iAnim, iSound, Float: flNextAttackTime, Float: flIdleTime;

	switch(get_pdata_int(iItem, m_iWeaponState, linux_diff_weapon))
	{
		case WPNSTATE_TRAPS:
		{
			static iTraps; iTraps = get_pdata_int(iItem, m_iTrapsCount, linux_diff_weapon);
			if(!iTraps)
			{
				ExecuteHam(Ham_Weapon_PlayEmptySound, iItem);
				set_pdata_float(iItem, m_flNextPrimaryAttack, 0.2, linux_diff_weapon);

				return HAM_SUPERCEDE;
			}

			iTraps--;

			UTIL_StatusIcon(iItem, iPlayer, 0);
			set_pdata_int(iItem, m_iTrapsCount, iTraps, linux_diff_weapon);
			UTIL_StatusIcon(iItem, iPlayer, 1);

			iAnim = WEAPON_ANIM_SHOOT_NET; iSound = 1;
			flIdleTime = flNextAttackTime = WEAPON_ANIM_SHOOT_TIME;

			CWeapon__Create_NetMissile(iPlayer);
		}
		case WPNSTATE_ZOOM, WPNSTATE_ZOOM_SHOOT:
		{
			static fw_TraceLine; fw_TraceLine = register_forward(FM_TraceLine, "FM_Hook_TraceLine_Post", true);
			static fw_PlayBackEvent; fw_PlayBackEvent = register_forward(FM_PlaybackEvent, "FM_Hook_PlaybackEvent_Pre", false);
			fm_ham_hook(true);

			ExecuteHam(Ham_Weapon_PrimaryAttack, iItem);

			unregister_forward(FM_TraceLine, fw_TraceLine, true);
			unregister_forward(FM_PlaybackEvent, fw_PlayBackEvent);
			fm_ham_hook(false);

			// After shoot return last zoom
			if(get_pdata_int(iPlayer, m_iFOV, linux_diff_player) != 90)
			{
				set_pdata_int(iPlayer, m_bResumeZoom, 1, linux_diff_player);
				set_pdata_int(iPlayer, m_iLastZoom, get_pdata_int(iPlayer, m_iFOV, linux_diff_player), linux_diff_player);

				set_pdata_int(iPlayer, m_iFOV, 90, linux_diff_player);
				set_pdata_int(iItem, m_iWeaponState, WPNSTATE_ZOOM_SHOOT, linux_diff_weapon);

				UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[1], true);
				CPlayer__DefaultCrosshair(iPlayer, true);

				gl_bClientDataUpdated = false;
			}

			static Float: vecPunchangle[3];
			pev(iPlayer, pev_punchangle, vecPunchangle);
			vecPunchangle[0] *= WEAPON_PUNCHANGLE;
			vecPunchangle[1] *= WEAPON_PUNCHANGLE;
			vecPunchangle[2] *= WEAPON_PUNCHANGLE;
			set_pev(iPlayer, pev_punchangle, vecPunchangle);

			iAnim = WEAPON_ANIM_SHOOT + (weaponHasMaxHits(iItem) ? 6 : 0); iSound = 0;
			flNextAttackTime = WEAPON_RATE;
			flIdleTime = WEAPON_ANIM_SHOOT_TIME;
		}
	}

	UTIL_SendWeaponAnim(iPlayer, iAnim);
	emit_sound(iPlayer, CHAN_WEAPON, WEAPON_SOUND_FIRE[iSound], VOL_NORM, ATTN_NORM, 0, PITCH_NORM);

	set_pdata_float(iItem, m_flNextPrimaryAttack, flNextAttackTime, linux_diff_weapon);
	set_pdata_float(iItem, m_flNextSecondaryAttack, flNextAttackTime, linux_diff_weapon);
	set_pdata_float(iItem, m_flTimeWeaponIdle, flIdleTime, linux_diff_weapon);

	return HAM_SUPERCEDE;
}

public CWeapon__SecondaryAtack_Pre(iItem)
{
	if(!IsCustomItem(iItem)) return HAM_IGNORED;

	static iWeaponState;
	static Float: flTime; flTime = 0.3;
	static iPlayer; iPlayer = get_pdata_cbase(iItem, m_pPlayer, linux_diff_weapon);
	static iFOV; iFOV = get_pdata_int(iPlayer, m_iFOV, linux_diff_player);

	iFOV = iFOV == 89 ? 55 : 89;
	iWeaponState = iFOV == 89 ? WPNSTATE_TRAPS : WPNSTATE_ZOOM;

	set_pdata_int(iPlayer, m_iFOV, iFOV, linux_diff_player);
	set_pdata_int(iItem, m_iWeaponState, iWeaponState, linux_diff_weapon);

	UTIL_WeaponList(iPlayer, WEAPON_WEAPONLIST[iWeaponState == WPNSTATE_TRAPS ? 0 : 1], true);
	if(iWeaponState == WPNSTATE_TRAPS)
		UTIL_SendWeaponAnim(iPlayer, WEAPON_ANIM_IDLE + (weaponHasMaxHits(iItem) ? 6 : 0));
	else CPlayer__UpdateZoom(iPlayer, iItem);

	gl_bClientDataUpdated = false;

	set_pdata_float(iItem, m_flNextPrimaryAttack, flTime, linux_diff_weapon);
	set_pdata_float(iItem, m_flNextSecondaryAttack, flTime, linux_diff_weapon);
	set_pdata_float(iItem, m_flTimeWeaponIdle, flTime, linux_diff_weapon);

	return HAM_SUPERCEDE;
}

public CEntity__Touch_Pre(iEntity, iTouch)
{
	if(pev_valid(iEntity) != PDATA_SAFE) return HAM_IGNORED;
	if(pev(iEntity, pev_classname) == gl_iszAllocString_NetMissile)
	{
		new iOwner = pev(iEntity, pev_owner);
		new Float: vecOrigin[3]; pev(iEntity, pev_origin, vecOrigin);

		if(engfunc(EngFunc_PointContents, vecOrigin) == CONTENTS_SKY)
		{
			set_pev(iEntity, pev_flags, FL_KILLME);
			return HAM_IGNORED;
		}

		if(iTouch == iOwner) return HAM_SUPERCEDE;
		if(iTouch && pev_valid(iTouch))
		{
			if(is_user_alive(iTouch) && zp_get_user_zombie(iTouch))
			{
				new bVictimTrapped = pev(iTouch, pev_bTrapped);
				if(bVictimTrapped) return HAM_IGNORED;

				new iTrap = CWeapon__Create_NetTrap(iTouch);
				if(!(pev(iTouch, pev_flags) & FL_ONGROUND))
				{
					engfunc(EngFunc_DropToFloor, iTouch);

					pev(iTouch, pev_origin, vecOrigin);
					set_pev(iTrap, pev_origin, vecOrigin);
				}

				set_pev(iTouch, pev_bTrapped, 1);
				set_pev(iTouch, pev_velocity, Float: {0.0, 0.0, 0.0});

				UTIL_CreateExplosion(0, vecOrigin, 0.0, gl_iszModelIndex_Resources[0], 10, 32, 2|4|8);
			}
			else set_pev(iEntity, pev_flags, FL_KILLME);
		}
		else if(!iTouch)
		{
			set_pev(iEntity, pev_flags, FL_KILLME);
		}
	}
	if(pev(iEntity, pev_classname) == gl_iszAllocString_Tiger)
	{
		new iOwner = pev(iEntity, pev_owner);
		new Float: vecOrigin[3]; pev(iEntity, pev_origin, vecOrigin);

		if(engfunc(EngFunc_PointContents, vecOrigin) == CONTENTS_SKY)
		{
			set_pev(iEntity, pev_flags, FL_KILLME);
			return HAM_IGNORED;
		}

		if(iTouch == iOwner) return HAM_SUPERCEDE;
		if(iTouch && pev_valid(iTouch))
		{
			if(is_user_alive(iTouch) && zp_get_user_zombie(iTouch))
			{
				new Float: flGameTime = get_gametime();
				new Float: flDmgTime; pev(iTouch, pev_dmgtime, flDmgTime);
			
				new bVictimScratched = pev(iTouch, pev_bScratched);
				if(!bVictimScratched)
				{
					CWeapon__Create_Scratch(iTouch);
					set_pev(iTouch, pev_bScratched, 1);
				}

				if(flDmgTime <= flGameTime && get_user_weapon(iOwner) != CSW_KNIFE)
				{
					if(is_user_alive(iTouch))
						set_pdata_int(iTouch, m_LastHitGroup, HIT_GENERIC, linux_diff_player);

					ExecuteHamB(Ham_TakeDamage, iTouch, iOwner, iOwner, ENTITY_TIGER_DAMAGE, ENTITY_TIGER_DMGTYPE);
				
					set_pev(iTouch, pev_dmgtime, flGameTime + ENTITY_TIGER_DMGTIME);
				}
				else {}
			}
		}
	}

	return HAM_IGNORED;
}

public CEntity__Think_Pre(iEntity)
{
	if(pev_valid(iEntity) != PDATA_SAFE) return HAM_IGNORED;
	if(pev(iEntity, pev_classname) == gl_iszAllocString_NetTrap)
	{
		new iOwner = pev(iEntity, pev_owner);
		static Float: flLifeTime; pev(iEntity, pev_ltime, flLifeTime);
		if(flLifeTime < get_gametime())
		{
			set_pev(iOwner, pev_bTrapped, 0);
			set_pev(iEntity, pev_flags, FL_KILLME);
		}
		else
		{
			set_pev(iOwner, pev_velocity, Float: {0.0, 0.0, 0.0});
			set_pev(iEntity, pev_nextthink, get_gametime() + 0.01);
		}
	}
	if(pev(iEntity, pev_classname) == gl_iszAllocString_Tiger)
	{
		if(get_entity_out_of_world(iEntity))
		{
			set_pev(iEntity, pev_flags, FL_KILLME);
			return HAM_IGNORED;
		}

		set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);
	}
	if(pev(iEntity, pev_classname) == gl_iszAllocString_Scratch)
	{
		static Float: flGameTime; flGameTime = get_gametime();
		static Float: flRemoveTime; pev(iEntity, pev_ltime, flRemoveTime);
		if(flRemoveTime < flGameTime || pev(iEntity, pev_renderamt) <= 10.0)
		{
			new iOwner = pev(iEntity, pev_owner);

			set_pev(iOwner, pev_bScratched, 0);
			set_pev(iEntity, pev_flags, FL_KILLME);

			return HAM_IGNORED;
		}

		set_pev(iEntity, pev_renderamt, pev(iEntity, pev_renderamt) - 10.0);
		set_pev(iEntity, pev_nextthink, flGameTime + 0.1);
	}

	return HAM_IGNORED;
}

public CBeam__Think_Pre(iEntity)
{
	if(pev_valid(iEntity) != PDATA_SAFE) return HAM_IGNORED;
	if(pev(iEntity, pev_classname) == gl_iszAllocString_Beam)
	{
		if(pev(iEntity, pev_renderamt) <= 20.0)
		{
			set_pev(iEntity, pev_flags, FL_KILLME);

			return HAM_IGNORED;
		}

		set_pev(iEntity, pev_renderamt, pev(iEntity, pev_renderamt) - 20.0);
		set_pev(iEntity, pev_nextthink, get_gametime() + ENTITY_BEAM_NEXTTHINK);
	}

	return HAM_IGNORED;
}

public CEntity__TraceAttack_Pre(iVictim, iAttacker, Float: flDamage)
{
	if(!is_user_connected(iAttacker)) return;

	static iItem; iItem = get_pdata_cbase(iAttacker, m_pActiveItem, linux_diff_player);
	if(pev_valid(iItem) != PDATA_SAFE || !IsCustomItem(iItem)) return;

	if(is_user_alive(iVictim) && zp_get_user_zombie(iVictim) && !weaponHasMaxHits(iItem))
		set_pdata_int(iItem, m_iHitCount, get_pdata_int(iItem, m_iHitCount, linux_diff_weapon) + 1, linux_diff_weapon);

	SetHamParamFloat(3, flDamage * WEAPON_DAMAGE);
}

// [ Other ]
public CWeapon__Create_NetMissile(iPlayer)
{
	new iEntity = engfunc(EngFunc_CreateNamedEntity, gl_iszAllocString_InfoTarget);
	if(!iEntity) return FM_NULLENT;

	new Float: vecOrigin[3]; pev(iPlayer, pev_origin, vecOrigin);
	new Float: vecViewOfs[3]; pev(iPlayer, pev_view_ofs, vecViewOfs);
	new Float: vecAngles[3]; pev(iPlayer, pev_v_angle, vecAngles);
	new Float: vecForward[3]; angle_vector(vecAngles, ANGLEVECTOR_FORWARD, vecForward);
	new Float: vecVelocity[3]; xs_vec_copy(vecForward, vecVelocity);

	// Start Origin
	xs_vec_mul_scalar(vecForward, 10.0, vecForward);
	xs_vec_add(vecViewOfs, vecForward, vecViewOfs);
	xs_vec_add(vecOrigin, vecViewOfs, vecOrigin);

	// Speed for missile
	xs_vec_mul_scalar(vecVelocity, ENTITY_NETM_SPEED, vecVelocity);

	set_pev_string(iEntity, pev_classname, gl_iszAllocString_NetMissile);
	set_pev(iEntity, pev_movetype, MOVETYPE_TOSS);
	set_pev(iEntity, pev_solid, SOLID_TRIGGER);
	set_pev(iEntity, pev_owner, iPlayer);
	set_pev(iEntity, pev_velocity, vecVelocity);
	set_pev(iEntity, pev_gravity, 1.0);

	engfunc(EngFunc_VecToAngles, vecVelocity, vecAngles);
	set_pev(iEntity, pev_angles, vecAngles);

	set_pev(iEntity, pev_rendermode, kRenderTransAdd);
	set_pev(iEntity, pev_renderamt, 255.0);

	set_entity_anim(iEntity, 0);

	engfunc(EngFunc_SetModel, iEntity, ENTITY_NETM_MODEL);
	engfunc(EngFunc_SetSize, iEntity, Float: {0.0, -3.0, 0.0}, Float: {0.0, 3.0, 0.0});
	engfunc(EngFunc_SetOrigin, iEntity, vecOrigin);

	return iEntity;
}

public CWeapon__Create_NetTrap(iPlayer)
{
	new iEntity = engfunc(EngFunc_CreateNamedEntity, gl_iszAllocString_InfoTarget);
	if(!iEntity) return FM_NULLENT;

	new vecOrigin[3]; pev(iPlayer, pev_origin, vecOrigin);

	set_pev_string(iEntity, pev_classname, gl_iszAllocString_NetTrap);
	set_pev(iEntity, pev_movetype, MOVETYPE_NONE);
	set_pev(iEntity, pev_solid, SOLID_TRIGGER);
	set_pev(iEntity, pev_owner, iPlayer);
	set_pev(iEntity, pev_ltime, get_gametime() + 2.5);
	set_pev(iEntity, pev_nextthink, get_gametime() + 0.01);

	set_pev(iEntity, pev_rendermode, kRenderTransAdd);
	set_pev(iEntity, pev_renderamt, 255.0);

	set_entity_anim(iEntity, 0);

	engfunc(EngFunc_SetModel, iEntity, ENTITY_NETTRAP_MODEL);
	engfunc(EngFunc_SetOrigin, iEntity, vecOrigin);

	return iEntity;
}

public CWeapon__Create_Tiger(iPlayer)
{
	new iEntity = engfunc(EngFunc_CreateNamedEntity, gl_iszAllocString_InfoTarget);
	if(!iEntity) return FM_NULLENT;

	new Float: vecOrigin[3]; pev(iPlayer, pev_origin, vecOrigin);
	new Float: vecViewOfs[3]; pev(iPlayer, pev_view_ofs, vecViewOfs);
	new Float: vecAngles[3]; pev(iPlayer, pev_v_angle, vecAngles);
	new Float: vecForward[3]; angle_vector(vecAngles, ANGLEVECTOR_FORWARD, vecForward);
	new Float: vecVelocity[3]; xs_vec_copy(vecForward, vecVelocity);

	// Start Origin
	xs_vec_mul_scalar(vecForward, 20.0, vecForward);
	xs_vec_add(vecViewOfs, vecForward, vecViewOfs);
	xs_vec_add(vecOrigin, vecViewOfs, vecOrigin);
	vecOrigin[2] -= 40.0;

	// Speed for missile
	xs_vec_mul_scalar(vecVelocity, ENTITY_TIGER_SPEED, vecVelocity);

	set_pev_string(iEntity, pev_classname, gl_iszAllocString_Tiger);
	set_pev(iEntity, pev_solid, SOLID_TRIGGER);
	set_pev(iEntity, pev_movetype, MOVETYPE_NOCLIP);
	set_pev(iEntity, pev_owner, iPlayer);
	set_pev(iEntity, pev_velocity, vecVelocity);
	set_pev(iEntity, pev_nextthink, get_gametime() + 1.0);

	engfunc(EngFunc_VecToAngles, vecVelocity, vecAngles);
	set_pev(iEntity, pev_angles, vecAngles);

	set_pev(iEntity, pev_rendermode, kRenderTransAdd);
	set_pev(iEntity, pev_renderamt, 255.0);

	set_entity_anim(iEntity, 0);

	engfunc(EngFunc_SetModel, iEntity, ENTITY_TIGER_MODEL);
	engfunc(EngFunc_SetSize, iEntity, {-100.0, -50.0, 0.0}, {300.0, 50.0, 200.0});
	engfunc(EngFunc_SetOrigin, iEntity, vecOrigin);

	emit_sound(iPlayer, CHAN_WEAPON, WEAPON_SOUND_FIRE[2], VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	emit_sound(iEntity, CHAN_ITEM, ENTITY_TIGER_SOUND, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);

	return iEntity;
}

public CWeapon__Create_BeamLine(iPlayer, iItem, Float: vecEndPos[3])
{
	if(global_get(glb_maxEntities) - engfunc(EngFunc_NumberOfEntities) < 100) return FM_NULLENT;

	new Float: vecStart[3];
	UTIL_GetWeaponPosition(iPlayer, 80.0, get_cvar_num("cl_righthand") ? 10.0 : -10.0, -10.0, vecStart);

	new iBeam = Beam_Create(ENTITY_BEAM_SPRITE, ENTITY_BEAM_WIDTH);

	Beam_PointsInit(iBeam, vecEndPos, vecStart);
	Beam_SetBrightness(iBeam, ENTITY_BEAM_BRIGHTNESS);
	Beam_SetColor(iBeam, Float: ENTITY_BEAM_COLOR);
	Beam_SetFlags(iBeam, BEAM_FSINE);
	Beam_SetScrollRate(iBeam, ENTITY_BEAM_SCROLLRATE);

	set_pev_string(iBeam, pev_classname, gl_iszAllocString_Beam);
	set_pev(iBeam, pev_nextthink, get_gametime() + ENTITY_BEAM_NEXTTHINK);

	return iBeam;
}

public CWeapon__Create_Scratch(iPlayer)
{
	new iEntity = engfunc(EngFunc_CreateNamedEntity, gl_iszAllocString_InfoTarget);
	if(!iEntity) return FM_NULLENT;

	new Float: vecOrigin[3]; pev(iPlayer, pev_origin, vecOrigin);

	set_pev_string(iEntity, pev_classname, gl_iszAllocString_Scratch);
	set_pev(iEntity, pev_solid, SOLID_NOT);
	set_pev(iEntity, pev_movetype, MOVETYPE_FOLLOW);
	set_pev(iEntity, pev_owner, iPlayer);
	set_pev(iEntity, pev_aiment, iPlayer);
	set_pev(iEntity, pev_nextthink, get_gametime() + 0.1);
	set_pev(iEntity, pev_ltime, get_gametime() + ENTITY_SCRATCH_LIFETIME);
	set_pev(iEntity, pev_scale, 0.5);

	set_pev(iEntity, pev_rendermode, kRenderTransAdd);
	set_pev(iEntity, pev_renderamt, 255.0);

	engfunc(EngFunc_SetModel, iEntity, ENTITY_SCRATCH_SPRITE);
	engfunc(EngFunc_SetOrigin, iEntity, vecOrigin);

	return iEntity;
}

public CPlayer__UpdateZoom(iPlayer, iItem)
{
	UTIL_SendWeaponAnim(iPlayer, weaponHasMaxHits(iItem) ? WEAPON_ANIM_ZOOM_TARGET : WEAPON_ANIM_ZOOM);
}

public CPlayer__DefaultCrosshair(iPlayer, bool: bEnabled)
{
	if(!is_user_connected(iPlayer)) return;

	if(bEnabled)
		UTIL_UpdateHideWeapon(iPlayer, get_pdata_int(iPlayer, m_iHideHUD, linux_diff_player) & ~HIDEHUD_CROSSHAIR);
	else
		UTIL_UpdateHideWeapon(iPlayer, get_pdata_int(iPlayer, m_iHideHUD, linux_diff_player) | HIDEHUD_CROSSHAIR);

	#if SERVER_HAS_MONEY_SYSTEM == false
		UTIL_UpdateHideWeapon(iPlayer, get_pdata_int(iPlayer, m_iHideHUD, linux_diff_player) | HIDEHUD_MONEY);
	#endif

	static iItem; iItem = get_pdata_cbase(iPlayer, m_pActiveItem, linux_diff_player);
	if(pev_valid(iItem) == PDATA_SAFE && IsCustomItem(iItem))
	{
		static iClip; iClip = get_pdata_int(iItem, m_iClip, linux_diff_weapon);

		message_begin(MSG_ONE, gl_iMsgID_CurWeapon, _, iPlayer);
		write_byte(true);
		write_byte(iWeaponList[6]);
		write_byte(iClip);
		message_end();
	}
}

public fm_ham_hook(bool: bEnabled)
{
	if(bEnabled)
	{
		EnableHamForward(gl_HamHook_TraceAttack[0]);
		EnableHamForward(gl_HamHook_TraceAttack[1]);
		EnableHamForward(gl_HamHook_TraceAttack[2]);
		EnableHamForward(gl_HamHook_TraceAttack[3]);
	}
	else 
	{
		DisableHamForward(gl_HamHook_TraceAttack[0]);
		DisableHamForward(gl_HamHook_TraceAttack[1]);
		DisableHamForward(gl_HamHook_TraceAttack[2]);
		DisableHamForward(gl_HamHook_TraceAttack[3]);
	}
}

// [ Stocks ]
stock set_entity_anim(iEntity, iSequence)
{
	set_pev(iEntity, pev_frame, 1.0);
	set_pev(iEntity, pev_framerate, 1.0);
	set_pev(iEntity, pev_animtime, get_gametime());
	set_pev(iEntity, pev_sequence, iSequence);
}

stock get_entity_out_of_world(iEntity)
{
	if(pev_valid(iEntity) != PDATA_SAFE) return -1;

	static Float: vecOrigin[3]; pev(iEntity, pev_origin, vecOrigin);
	if(-8192.0 <= vecOrigin[0] >= 8192.0 || -8192.0 <= vecOrigin[1] >= 8192.0 || -8192.0 <= vecOrigin[2] <= -8192.0)
		return true;

	return -1;
}

stock get_weapon_penetration(iItem)
{
	if(pev_valid(iItem) != PDATA_SAFE) return -1;

	switch(get_pdata_int(iItem, m_iId, linux_diff_weapon))
	{
		case CSW_ELITE, CSW_FIVESEVEN, CSW_GLOCK18, CSW_MAC10, CSW_MP5NAVY, CSW_P228, CSW_P90, CSW_TMP, CSW_UMP45, CSW_USP: return 1;
		case CSW_AK47, CSW_AUG, CSW_DEAGLE, CSW_FAMAS, CSW_GALIL, CSW_M249, CSW_M4A1, CSW_SG550, CSW_SG552: return 2;
		case CSW_AWP, CSW_G3SG1, CSW_SCOUT: return 3;
	}

	return -1;
}

stock UTIL_SendWeaponAnim(iPlayer, iAnim)
{
	set_pev(iPlayer, pev_weaponanim, iAnim);

	message_begin(MSG_ONE, SVC_WEAPONANIM, _, iPlayer);
	write_byte(iAnim);
	write_byte(0);
	message_end();
}

stock UTIL_DropWeapon(iPlayer, iSlot)
{
	static iEntity, iNext, szWeaponName[32];
	iEntity = get_pdata_cbase(iPlayer, m_rpgPlayerItems + iSlot, linux_diff_player);

	if(pev_valid(iEntity) == PDATA_SAFE)
	{
		do
		{
			iNext = get_pdata_cbase(iEntity, m_pNext, linux_diff_weapon);

			if(get_weaponname(get_pdata_int(iEntity, m_iId, linux_diff_weapon), szWeaponName, charsmax(szWeaponName)))
				engclient_cmd(iPlayer, "drop", szWeaponName);
		}
		
		while((iEntity = iNext) > 0);
	}
}

stock UTIL_GetWeaponPosition(iPlayer, Float: flForward, Float: flRight, Float: flUp, Float: vecStart[]) 
{
	static Float: vecOrigin[3], Float: vecAngle[3], Float: vecForward[3], Float: vecRight[3], Float: vecUp[3];
	
	pev(iPlayer, pev_origin, vecOrigin);
	pev(iPlayer, pev_view_ofs, vecUp);
	xs_vec_add(vecOrigin, vecUp, vecOrigin);
	pev(iPlayer, pev_v_angle, vecAngle);
	
	angle_vector(vecAngle, ANGLEVECTOR_FORWARD, vecForward);
	angle_vector(vecAngle, ANGLEVECTOR_RIGHT, vecRight);
	angle_vector(vecAngle, ANGLEVECTOR_UP, vecUp);
	
	vecStart[0] = vecOrigin[0] + vecForward[0] * flForward + vecRight[0] * flRight + vecUp[0] * flUp;
	vecStart[1] = vecOrigin[1] + vecForward[1] * flForward + vecRight[1] * flRight + vecUp[1] * flUp;
	vecStart[2] = vecOrigin[2] + vecForward[2] * flForward + vecRight[2] * flRight + vecUp[2] * flUp;
}

stock UTIL_CreateExplosion(iEntity, Float: vecOrigin[3], Float: vecUp, iszModelIndex, iScale, iFrameRate, iFlags)
{
	// https://github.com/baso88/SC_AngelScript/wiki/TE_EXPLOSION
	if(!iEntity)
		engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, vecOrigin, 0);
	else message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, iEntity);

	write_byte(TE_EXPLOSION); // TE
	engfunc(EngFunc_WriteCoord, vecOrigin[0]); // Position X
	engfunc(EngFunc_WriteCoord, vecOrigin[1]); // Position Y
	engfunc(EngFunc_WriteCoord, vecOrigin[2] + vecUp); // Position Z
	write_short(iszModelIndex); // Model Index
	write_byte(iScale); // Scale
	write_byte(iFrameRate); // Framerate
	write_byte(iFlags); // Flags
	message_end();
}

stock UTIL_PrecacheSoundsFromModel(const szModelPath[])
{
	new iFile;
	
	if((iFile = fopen(szModelPath, "rt")))
	{
		new szSoundPath[64];
		
		new iNumSeq, iSeqIndex;
		new iEvent, iNumEvents, iEventIndex;
		
		fseek(iFile, 164, SEEK_SET);
		fread(iFile, iNumSeq, BLOCK_INT);
		fread(iFile, iSeqIndex, BLOCK_INT);
		
		for(new k, i = 0; i < iNumSeq; i++)
		{
			fseek(iFile, iSeqIndex + 48 + 176 * i, SEEK_SET);
			fread(iFile, iNumEvents, BLOCK_INT);
			fread(iFile, iEventIndex, BLOCK_INT);
			fseek(iFile, iEventIndex + 176 * i, SEEK_SET);
			
			for(k = 0; k < iNumEvents; k++)
			{
				fseek(iFile, iEventIndex + 4 + 76 * k, SEEK_SET);
				fread(iFile, iEvent, BLOCK_INT);
				fseek(iFile, 4, SEEK_CUR);
				
				if(iEvent != 5004)
					continue;
				
				fread_blocks(iFile, szSoundPath, 64, BLOCK_CHAR);
				
				if(strlen(szSoundPath))
				{
					strtolower(szSoundPath);
					engfunc(EngFunc_PrecacheSound, szSoundPath);
				}
			}
		}
	}
	
	fclose(iFile);
}

stock UTIL_PrecacheSpritesFromTxt(const szWeaponList[])
{
	new szTxtDir[64], szSprDir[64]; 
	new szFileData[128], szSprName[48], temp[1];

	format(szTxtDir, charsmax(szTxtDir), "sprites/%s.txt", szWeaponList);
	engfunc(EngFunc_PrecacheGeneric, szTxtDir);

	new iFile = fopen(szTxtDir, "rb");
	while(iFile && !feof(iFile)) 
	{
		fgets(iFile, szFileData, charsmax(szFileData));
		trim(szFileData);

		if(!strlen(szFileData)) 
			continue;

		new pos = containi(szFileData, "640");	
			
		if(pos == -1)
			continue;
			
		format(szFileData, charsmax(szFileData), "%s", szFileData[pos+3]);		
		trim(szFileData);

		strtok(szFileData, szSprName, charsmax(szSprName), temp, charsmax(temp), ' ', 1);
		trim(szSprName);
		
		format(szSprDir, charsmax(szSprDir), "sprites/%s.spr", szSprName);
		engfunc(EngFunc_PrecacheGeneric, szSprDir);
	}

	if(iFile) fclose(iFile);
}

stock UTIL_WeaponList(iPlayer, const szWeaponList[], bool: bEnabled)
{
	message_begin(MSG_ONE, gl_iMsgID_Weaponlist, _, iPlayer);
	write_string(bEnabled ? szWeaponList : WEAPON_REFERENCE);
	write_byte(iWeaponList[0]);
	write_byte(bEnabled ? WEAPON_DEFAULT_AMMO : iWeaponList[1]);
	write_byte(iWeaponList[2]);
	write_byte(iWeaponList[3]);
	write_byte(iWeaponList[4]);
	write_byte(iWeaponList[5]);
	write_byte(iWeaponList[6]);
	write_byte(iWeaponList[7]);
	message_end();
}

stock UTIL_UpdateHideWeapon(iPlayer, iFlags)
{
	message_begin(MSG_ONE, gl_iMsgID_HideWeapon, _, iPlayer);
	write_byte(iFlags);
	message_end();

	set_pdata_int(iPlayer, m_iHideHUD, iFlags, linux_diff_player);
	set_pdata_int(iPlayer, m_iClientHideHUD, iFlags, linux_diff_player);
}

stock UTIL_StatusIcon(iItem, iPlayer, iUpdateMode)
{
	new szSprite[33];
	new iClip = get_pdata_int(iItem, m_iTrapsCount, linux_diff_weapon);
	if(iClip > 9) format(szSprite, charsmax(szSprite), "escape");
	else format(szSprite, charsmax(szSprite), "number_%d", iClip);

	message_begin(MSG_ONE, gl_iMsgID_StatusIcon, { 0, 0, 0 }, iPlayer);
	if(iUpdateMode && iClip > 0) write_byte(1);
	else write_byte(0);
	write_string(szSprite);
	write_byte(255);
	write_byte(128);
	write_byte(0);
	message_end();
}
